#!/usr/bin/env python
'''
    This will take an existing updateinfo xml and merge duplicate entries
'''

from updateinfo import Updateinfo

import datetime
import sys
import tempfile

class UpdateinfoDeDupe(object):
    '''
        This class takes an xml file in updateinfo style
         and de-duplicates it
    '''
    def __init__(self):
        '''
            basic setup
        '''
        self.updateinfo = Updateinfo()

    def __str__(self):
        '''
            for print obj
        '''
        now = str(datetime.datetime.now())
        text = self.updateinfo.get_xml(validate=False, pretty=True, comment=now)
        return str(text)

    def merge_file(self, filename):
        '''
            pass in a filename and it will get merged into
            a unified xml file here
        '''
        self.updateinfo.merge_with_file(filename)

    def merge_str(self, text):
        '''
            pass in valid 'updateinfo' like xml
        '''
        temp = tempfile.NamedTemporaryFile(bufsize=0)
        temp.write(text)
        self.merge_file(temp.name)
        temp.close()

if __name__ == "__main__":

    if len(sys.argv) != 2:
        print >> sys.stderr, " You must provide a file to parse"
        print >> sys.stderr, "    ie. '/my/big/updateinfofile.xml'"
        sys.exit(1)

    THING = UpdateinfoDeDupe()
    THING.merge_file(sys.argv[1])

    print THING
